import csv
import unittest

# rešuj pod tem komentarjem



class BancneKrizeTestCase(unittest.TestCase):
    def test_preberi_podatke(self):
        podatki = preberi_podatke("banking-crises.csv")
        self.assertEqual(212, len(podatki))
        self.assertEqual(71, len(podatki[1]))
        self.assertListEqual(
            ["", "Algeria", "Angola", "Argentina", "Australia"], podatki[0][:5]
        )
        self.assertListEqual(
            ["", "1800", "1801", "1802", "1803"], [v[0] for v in podatki[:5]]
        )
        self.assertListEqual(
            ["Angola", "0", "0", "0", "0"], [v[2] for v in podatki[:5]]
        )
        self.assertListEqual(["0", "0", "1", "1", "1"], [v[5] for v in podatki[-5:]])

    def test_uredi_podatke(self):
        podatki = preberi_podatke("banking-crises.csv")
        urejeni = uredi_podatke(podatki)
        self.assertEqual(212, len(podatki))
        self.assertEqual(71, len(podatki[1]))
        self.assertListEqual(
            ["", "Algeria", "Angola", "Argentina", "Australia"], urejeni[0][:5]
        )
        self.assertListEqual(["", 1800, 1801, 1802, 1803], [v[0] for v in urejeni[:5]])
        self.assertListEqual(
            ["Angola", False, False, False, False], [v[2] for v in urejeni[:5]]
        )
        self.assertListEqual(
            [False, False, True, True, True], [v[5] for v in urejeni[-5:]]
        )

    def test_leta_brez_krize(self):
        podatki = uredi_podatke(preberi_podatke("banking-crises.csv"))
        # fmt: off
        self.assertListEqual(
            [1800, 1801, 1803, 1804, 1806, 1807, 1808, 1809, 1830, 1831, 1832,
             1833, 1834, 1835, 1841, 1844, 1845, 1851, 1852, 1853, 1854, 1855,
             1858, 1859, 1860, 1861, 1886, 1888, 1903, 1904, 1905, 1909, 1918,
             1919, 1938, 1940, 1941, 1942, 1943, 1944, 1945, 1946, 1949, 1950,
             1951, 1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960, 1961,
             1962, 1964, 1965, 1966, 1967, 1968, 1969, 1970, 1972, 1973],
            leta_brez_krize(podatki)
        )
        # fmt: on

    def test_drzava_brez_krize(self):
        podatki = uredi_podatke(preberi_podatke("banking-crises.csv"))
        self.assertListEqual(["Mauritius"], drzave_brez_krize(podatki))

    def test_samo_krize(self):
        podatki = uredi_podatke(preberi_podatke("banking-crises.csv"))
        rezultat = samo_krize(podatki)
        self.assertEqual(len(podatki) - 1, len(rezultat))
        self.assertEqual(len(podatki[0]) - 1, len(rezultat[0]))
        self.assertEqual(podatki[1][1], rezultat[0][0])  # 0
        self.assertEqual(podatki[-1][5], rezultat[-1][4])  # 1

    def test_najvec_kriz(self):
        podatki = uredi_podatke(preberi_podatke("banking-crises.csv"))
        rezultat = samo_krize(podatki)
        self.assertEqual(31, najvec_kriz(rezultat))


if __name__ == "__main__":
    unittest.main()
